// /////////////////////////////////////////////////////////////////////////
// C++ code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#include "../inc/actuator.hpp"



actuator::actuator() :
    pwdata_old(0UL),
    pwrite_old(false),
    penable_old(false),
    psel_old(false),
    paddr_old(0UL),
    presetn_old(false),
    pclk_old(false),
    hif_a2t_data(
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr),
    actuator_open_reg(false),
    actuator_close_reg(false),
    actuator_threshold_reg(uint16_t(0U)),
    actuator_open_reg_new(false),
    actuator_close_reg_new(false),
    actuator_threshold_reg_new(uint16_t(0U)),
    process_in_queue(false),
    flag_initial_process_executed(false),
    flag_process_executed(false),
    flag_pos_pclk(false)
{
}


actuator::~actuator()
{}


void actuator::initial_process()
{
    *hif_a2t_data.actuator_open = false;
    *hif_a2t_data.actuator_close = false;
    *hif_a2t_data.actuator_threshold = uint16_t(0U);
    actuator_open_reg_new = false;
    actuator_close_reg_new = false;
    actuator_threshold_reg_new = uint16_t(0U);
}


void actuator::process()
{
    *hif_a2t_data.actuator_open = actuator_open_reg;
    *hif_a2t_data.actuator_close = actuator_close_reg;
    *hif_a2t_data.actuator_threshold = actuator_threshold_reg;
    if (*hif_a2t_data.penable)
    {
        actuator_open_reg_new = *hif_a2t_data.pwdata & 1UL;
        actuator_close_reg_new = *hif_a2t_data.pwdata >> 8UL & 1UL;
        actuator_threshold_reg_new = *hif_a2t_data.pwdata >> 16L & 65535UL;
        *hif_a2t_data.pready = true;
    }
    else
    {
        *hif_a2t_data.pready = false;
    }
}


void actuator::update_input_queue( bool synch_phase )
{
    process_in_queue = false;
    if (*hif_a2t_data.pclk != pclk_old)
    {
        pclk_old = *hif_a2t_data.pclk;
        if (*hif_a2t_data.pclk == true)
        {
            flag_pos_pclk = true;
        }
        else
        {
            flag_pos_pclk = false;
        }
        process_in_queue = true;
    }
    else
    {
        flag_pos_pclk = false;
    }
    presetn_old = *hif_a2t_data.presetn;
    paddr_old = *hif_a2t_data.paddr;
    psel_old = *hif_a2t_data.psel;
    penable_old = *hif_a2t_data.penable;
    pwrite_old = *hif_a2t_data.pwrite;
    pwdata_old = *hif_a2t_data.pwdata;
}


void actuator::update_event_queue()
{
    process_in_queue = false;
    update_input_queue( false );
    actuator_close_reg = actuator_close_reg_new;
    actuator_open_reg = actuator_open_reg_new;
    actuator_threshold_reg = actuator_threshold_reg_new;
}


void actuator::flag_elaboration()
{
    flag_process_executed = false;
    if (flag_pos_pclk)
    {
        process();
        flag_process_executed = true;
    }
}


void actuator::start_of_simulation()
{
    initial_process();
    flag_initial_process_executed = true;
    process();
    flag_process_executed = true;
}


void actuator::initialize()
{
    start_of_simulation();
}




